SHEBANG
# Copyright (C)2024 @BABOLO http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.2 2024/02/24 18:03:20 babolo Exp $

JNTROSTUP(aaacipa,,dnl
,dnl
# jailup ${kind} dir jailname jailaddr [uid [gid [conf]]]
#     where dir relative to ${JAILUPDIR} and ${JAILRODIR}
# ${inclass} from base system used
# Default genclass is "${inclass}".
dnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
juid="${4:-80}"
jgid="${5:-80}"
jconf="${6:-${kind}}"

main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"
if  [ -n "${CONFSHIFT}" ]; then
    conf_dir="${conf_dir}/${CONFSHIFT}"
fi

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}

if  [ -f LIBINCLUDEDIR/${kind}:bdb6.VERSION ]; then
    PATH="${PATH}:%%PREFIX%%/BerkeleyDB.6.2/bin"
    ln -s . ${main_dir}/BerkeleyDB.6.2
fi

if  [ -f LIBINCLUDEDIR/${kind}:bdb18.VERSION ]; then
    PATH="${PATH}:%%PREFIX%%/BerkeleyDB.18.1/bin"
    ln -s . ${main_dir}/BerkeleyDB.18.1
fi

${up_genlist} libexec/ ${MTREE} | ${up_libexe} "${main_dir}/libexec/"
${up_genlist} libexec/ ${MTREE} | ${up_ldsh} | ${up_shlib} "${main_dir}/libexec"
${up_genlist} bin/ ${MTREE} | ${up_libexe} "${main_dir}/bin/"
${up_genlist} bin/ ${MTREE} | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
ETCOPY()
CONFCOPY(${jconf}, "${TEMPLATE}")

${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:
	daemon:*:${jgid}:
	nogroup:*:65533:
	nobody:*:65534:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
EOF

if  [ "${juid}" != "80" ]; then
    ${up_acc} pwt "${conf_dir}" <<- EOF
	${inclass}:*:${juid}:${jgid}::0:0:${inclass}:/:/dev/null/none
EOF
fi

${up_mtree} "${main_dir}" ${MTREE}

${up_adc} "${JAILUPRC}" <<- EOF
	#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	0	0	${jconf}
EOF

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev		devfs	rw		0 0
	#${conf_dir}		${main_dir}/etc		nullfs	ro,noexec	0 0
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################
